import socket
import io
import json
import time

from colorama import Fore,Back, init
init()

SessionDesc={
    "dwSize":"I",
    "dwFlags":"I",
    "dwHost":"40s",# host's ip address (can fit a full IPv4 and IPv6 address + terminating NUL)
    "dwMaxPlayers":"I",
    "dwCurrentPlayers":"I",
    "dwUserFlags":["I" for _ in range(4)],# [ game.type, openSpectatorSlots, unused, unused ]
    }

GameStruct={
    "GAMESTRUCT_VERSION":"I",
    "name":"64s",
    "desc":SessionDesc,
    # END of old GAMESTRUCT format
    "secondaryHosts":["40s" for _ in range(2)],
    "extra":"157s",
    "hostPort":"H",
    "mapname":"40s",
    "hostname":"40s",
    "versionstring":"64s",
    "modlist":"255s",
    "game_version_major":"I",
    "game_version_minor":"I",
    "privateGame":"I",                    # if true, it is a private game
    "pureMap":"I",                        # If this map has mods in it.
    "Mods":"I",                            # number of concatenated mods?True
    # Game ID, used on the lobby server to link games with multiple address families to eachother
    "gameId":"I",
    "limits":"I",                            # holds limits bitmask (NO_VTOL|NO_TANKS|NO_BORGS)
    "future3":"I",                        # for future use
    "future4":"I",                        # for future use
}

from neststruct import Reader

while 1:
    #print("list")
    fi=io.BytesIO()
    addr=("65.21.236.11",9990)
    sock=socket.socket(socket.AF_INET, socket.SOCK_STREAM)

    try:
        sock.connect(addr)
        sock.settimeout(5)
        sock.send(b"list\n")
        while 1:
            x=sock.recv(4096)
            if x:
                fi.write(x)
            else:
                break
    except Exception as e:
        print(Fore.RED+str(e)+Fore.RESET)
        continue
    finally:
        sock.close()
    fi.seek(0)

    try:
        reader=Reader(fi)

        n=reader.load("I")
        bodyExpr=[GameStruct for i in range(n)]
        body=reader.load(bodyExpr)

        print("records:",n)
        for i in body:
            color=Fore.CYAN if i["hostname"]!="dummyhost" else ""
            color=Fore.GREEN if i["desc"]["dwCurrentPlayers"]>=i["desc"]["dwMaxPlayers"] else color
            color=Fore.YELLOW if i["privateGame"] else color

            print(color+i["hostname"],i["mapname"], "%s/%s"%(i["desc"]["dwCurrentPlayers"],i["desc"]["dwMaxPlayers"]),"%s:%d"%(i["desc"]["dwHost"],i["hostPort"]),i["modlist"],Fore.RESET) 
        lobbyStatusCode,MOTDLength=reader.load(["I","I"])
        motd=reader.load(f"{MOTDLength}s")

        checksum=reader.load("I")
        print(lobbyStatusCode,MOTDLength,checksum)
        assert checksum==1,"checksum"

        n2=reader.load("I")
        bodyExpr2=[GameStruct for i in range(n2)]
        body2=reader.load(bodyExpr2)
        assert body==body2,"body"
    except Exception as e:
        print(Fore.RED+str(e)+Fore.RESET)
        continue
    #print(body)

    with open("lobby.txt","a") as fi2:
        json.dump([time.time(),body],fi2)
        fi2.write("\n")
    
    try:
        time.sleep(30)
    except KeyboardInterrupt as e:
        break